// Generated by CoffeeScript 1.7.1
var assemble, between, betweenSkewed, canvas, capitalise, capitalize, directionFrom, duplicate, everything, know, knowHandwavily, knowIntimately, magnitude, noGlyph, oneIn, oneOf, oneOfSkewed, overlay, pluralise, pronoun, remove, roar, s, select, sentancize, smear, someOf;

oneOf = function(list) {
  try {
    return list[between(0, list.length)];
  } catch (_error) {}
};

between = function(min, max) {
  return Math.floor(Math.random() * (max - min) + min);
};

oneIn = function(odds) {
  return Math.random() * odds < 1;
};

magnitude = function(order) {
  var i;
  i = 0;
  while (oneIn(order)) {
    i++;
  }
  return i;
};

smear = function(number) {
  return Math.floor(number * (Math.random() + 0.5));
};

capitalize = function(string) {
  return string.charAt(0).toUpperCase() + string.substring(1);
};

capitalise = capitalize;

assemble = function(clauses, linker) {
  if (clauses.length === 0) {
    return "";
  }
  if (clauses.length === 1) {
    return clauses[0];
  }
  if (!linker) {
    linker = " and ";
  }
  return clauses.slice(0, +(clauses.length - 2) + 1 || 9e9).join(', ') + linker + clauses[clauses.length - 1];
};

pluralise = function(word) {
  switch (word) {
    case "fish":
      return oneOf(["fish", "fishes"]);
    case "octopus":
      return oneOf(["octopi", "octopodes", "octuples", "octopididilyididlybingbang"]);
    case "fungus":
      return "fungi";
  }
  if (word[word.length - 1] === "s") {
    return word + "es";
  } else {
    return word + "s";
  }
};

sentancize = function(string) {
  if (string[string.length - 1] !== ".") {
    string += ".";
  }
  return capitalize(string);
};

pronoun = function(thing) {
  if (thing === player) {
    return "you";
  } else if (thing.gender === "male") {
    return "he";
  } else if (thing.gender === "female") {
    return "she";
  } else if (thing.pluralNoun || thing.quantity > 1) {
    return "they";
  } else {
    return "it";
  }
};

know = function(thing) {
  var _ref;
  if (thing === player) {
    return "you";
  } else if (thing.owner === player) {
    return "your " + thing.name;
  } else if (thing.pluralNoun || thing.singular) {
    return thing.name;
  } else if (thing.quantity > 1 || ((_ref = thing.inside) != null ? _ref.quantity : void 0) > 1) {
    return pluralise(thing.name);
  } else {
    if (vowels.match(thing.name[0])) {
      return "an " + thing.name;
    } else {
      return "a " + thing.name;
    }
  }
};

knowIntimately = function(thing, second) {
  var _ref;
  if (thing === player) {
    if (!second) {
      return "you";
    } else {
      return "yourself";
    }
  } else if (thing.pluralNoun || thing.singular) {
    return thing.name;
  } else if (thing.quantity > 1 || ((_ref = thing.inside) != null ? _ref.quantity : void 0) > 1) {
    return "the " + pluralise(thing.name);
  } else {
    return "the " + thing.name;
  }
};

knowHandwavily = function(word) {
  if (vowels.match(word[0])) {
    return "an " + word;
  } else {
    return "a " + word;
  }
};

everything = function(list, name) {
  var thing, _i, _len, _results;
  _results = [];
  for (_i = 0, _len = list.length; _i < _len; _i++) {
    thing = list[_i];
    _results.push(thing[name]());
  }
  return _results;
};

oneOfSkewed = function(list) {
  return list[betweenSkewed(0, list.length)];
};

betweenSkewed = function(min, max) {
  return Math.floor(max - Math.sin(Math.random() * 1.5707) * (max - min));
};

s = function(thing) {
  if (thing !== player) {
    if (thing.name[thing.name.length - 1] === 's') {
      return 'es';
    } else {
      return 's';
    }
  } else {
    return '';
  }
};

remove = function(list, value) {
  var i;
  while ((i = list.indexOf(value)) !== -1) {
    list.splice(i, 1);
  }
  return value;
};

directionFrom = function(thing1, thing2) {
  var out;
  out = "";
  if (thing1.inside.location.y < thing2.inside.location.y) {
    out += "south";
  } else if (thing1.inside.location.y > thing2.inside.location.y) {
    out += "north";
  }
  if (thing1.inside.location.x < thing2.inside.location.x) {
    out += "east";
  } else if (thing1.inside.location.x > thing2.inside.location.x) {
    out += "west";
  }
  return out;
};

duplicate = function(thing) {
  var constructor, newThing;
  constructor = Object.getPrototypeOf(thing).constructor;
  newThing = new constructor(thing);
  newThing.contents = void 0;
  return newThing;
};

someOf = function(list, number) {
  var i, r, _i;
  r = [];
  for (i = _i = 0; 0 <= number ? _i < number : _i > number; i = 0 <= number ? ++_i : --_i) {
    r.push(remove(list, oneOf(list)));
  }
  return r;
};

select = function(list, condition) {
  var thing, _i, _len, _results;
  if (!list) {
    return [];
  }
  _results = [];
  for (_i = 0, _len = list.length; _i < _len; _i++) {
    thing = list[_i];
    if (condition(thing)) {
      _results.push(thing);
    } else {

    }
  }
  return _results;
};

canvas = document.createElement("canvas");

overlay = canvas.getContext("2d");

overlay.font = "40px Arial";

noGlyph = overlay.measureText("⮚").width;

roar = function(length) {
  var c, i, out, _i;
  out = "";
  for (i = _i = 0; 0 <= length ? _i < length : _i > length; i = 0 <= length ? ++_i : --_i) {
    c = String.fromCharCode(parseInt(Math.random() * 10000));
    if (overlay.measureText(c).width !== noGlyph) {
      out += c;
    }
  }
  return out;
};
