// Generated by CoffeeScript 1.7.1
var generateTestWorld,
  __hasProp = {}.hasOwnProperty,
  __extends = function(child, parent) { for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; };

generateTestWorld = function() {
  var Parrot, aleph, apple, braintree, bunny, canyon, copse, drawingRoom, entranceHall, etchings, kitchen, manorGarden, manorHouse, meadow, monster, nameEtchings, pants, portableHole, scullery, speak, sticker, study, windo, writing, zombie;
  Parrot = (function(_super) {
    __extends(Parrot, _super);

    function Parrot() {
      return Parrot.__super__.constructor.apply(this, arguments);
    }

    Parrot.prototype.hp = 20;

    return Parrot;

  })(Animal);
  bunny = new Animal({
    name: "bunny",
    description: "adorable flopsy-wopsy bunny with its original brain"
  });
  meadow = new Room({
    name: "meadow",
    description: "A sunny meadow with no braintrees."
  });
  copse = new Room({
    name: "copse",
    description: "A small copse of trees that are definately not braintrees."
  });
  canyon = new Room({
    name: "canyon",
    description: "Aaaaah! Aaaaaaaa! Oh my God! It's a braintreee!"
  });
  meadow.exits[4] = copse;
  copse.exits[0] = meadow;
  copse.exits[4] = canyon;
  canyon.exits[0] = copse;
  braintree = new Animal({
    name: "braintree",
    act: function() {
      if (oneIn(2)) {
        switch (magnitude(10)) {
          case 0:
            return speak(this, "announces", oneOf(getWords(FUN)));
          case 1:
            return speak(this, "hisses", oneOf(getWords(0)));
          case 2:
            return speak(this, "whispers", oneOf(heroes).name);
          case 3:
            return speak(this, "announces", oneOf(Object.keys(magicWords)));
          default:
            return speak(this, "whispers", oneOf(["Aras...", "Plotkin...", "Gjisbers..."]));
        }
      }
    }
  });
  apple = new Thing({
    name: "apple",
    relation: relation.hanging,
    quantity: 20
  });
  zombie = new Thing({
    name: "brain zombie",
    relation: relation.base
  });
  pants = new Thing({
    name: "moldy pants",
    relation: relation.base,
    pluralNoun: true
  });
  sticker = new Thing({
    name: "sticker",
    relation: relation.stuck
  });
  aleph = new Thing({
    name: "aleph",
    examine: function() {
      var i, result, _i;
      result = [];
      player.name += " (examining the aleph)";
      for (i = _i = 0; _i <= 100; i = ++_i) {
        result.push(lookAt(oneOf(objects)));
      }
      Say("Inside the aleph you see " + assemble(result) + ".");
      return player.name = player.name.slice(0, +(player.name.length - " (examining the aleph)".length) + 1 || 9e9);
    }
  });
  get(canyon, braintree);
  get(braintree, apple);
  get(braintree, zombie);
  get(braintree, pants);
  get(apple, sticker);
  get(meadow, bunny);
  get(meadow, aleph);
  manorGarden = new Room({
    name: "manor garden",
    description: "The grass is all equal height."
  });
  manorHouse = new Building({
    name: "manor house",
    description: "A abandoned manor from the Before Times."
  });
  get(manorGarden, manorHouse);
  entranceHall = new Room({
    name: "entrance hall"
  });
  get(manorHouse, entranceHall);
  kitchen = new Room({
    name: "kitchens"
  });
  get(manorHouse, kitchen);
  scullery = new Room({
    name: "scullery"
  });
  get(manorHouse, scullery);
  drawingRoom = new Room({
    name: "drawing room"
  });
  get(manorHouse, drawingRoom);
  study = new Room({
    name: "study"
  });
  get(manorHouse, study);
  meadow.exits[2] = manorGarden;
  manorGarden.exits = [];
  manorGarden.exits[6] = meadow;
  entranceHall.exits = [];
  entranceHall.exits[0] = kitchen;
  entranceHall.exits[2] = study;
  entranceHall.exits[4] = manorGarden;
  entranceHall.exits[6] = drawingRoom;
  kitchen.exits = [];
  kitchen.exits[4] = entranceHall;
  kitchen.exits[2] = scullery;
  scullery.exits = [];
  scullery.exits[6] = kitchen;
  drawingRoom.exits = [];
  drawingRoom.exits[2] = entranceHall;
  study.exits = [];
  study.exits[6] = entranceHall;
  monster = new Animal({
    name: "bunny monster",
    size: 20
  });
  get(meadow, monster);
  windo = new Window({
    outside: manorHouse,
    inside: drawingRoom
  });
  etchings = new Thing({
    pluralNoun: true,
    name: "the words 'Kilroy was here'",
    relation: relation.scratched,
    side: "inside"
  });
  get(windo, etchings);
  new Window({
    outside: manorHouse,
    inside: study
  });
  new Window({
    outside: scullery,
    inside: study
  });
  portableHole = new Thing({
    name: "portable hole"
  });
  get(drawingRoom, portableHole);
  writing = new Thing({
    pluralNoun: true,
    name: "the words 'mene mene tekel upharsin'",
    relation: relation.scratched
  });
  get(manorHouse, writing);
  speak = function(speaker, verb, statement) {
    var _ref;
    if (player.inside === speaker.inside) {
      Say("The " + (speaker.name()) + " " + verb + " \"" + (capitalize(statement)) + ".\"");
      return (_ref = magicWords[statement]) != null ? _ref.effect() : void 0;
    }
  };
  return nameEtchings = function(thing, examinee) {
    var etching, message, _i, _len, _ref, _results;
    _ref = thing.etchings;
    _results = [];
    for (_i = 0, _len = _ref.length; _i < _len; _i++) {
      etching = _ref[_i];
      if ((examinee.inside === thing.inside) === (etching.side === "inside")) {
        message = etching.text;
      } else {
        if (thing.material.transparent) {
          message = "<span style='display:inline-block; transform: scale(-1,1)'>" + etching.text + "</span>";
        } else {
          continue;
        }
      }
      _results.push(Say("&quot;" + message + "&quot; is " + etching.form + " on the " + (materialName(thing.material)) + "."));
    }
    return _results;
  };
};
